export interface CommandResult {
    error?: any;
    data?: any;
}
export interface ConnectionParams {
    model: string;
    port: string;
}
export interface Callbacks {
    onData?: (data: any) => void;
    onError?: (error: any) => void;
    onClose?: (exitCode: number) => void;
}
export declare enum Identificator {
    Port = 0,
    Model = 1
}
export declare type CaptureOptions = Partial<{
    keep: boolean;
    keepRAW: boolean;
    noKeep: boolean;
    bulb: number;
    frames: number;
    interval: number;
    resetInterval: boolean;
    filename: string;
    forceOverwrite: boolean;
    skipExisting: boolean;
}>;
export declare type BurstOptions = {
    length: number;
    filename?: string;
};
